import com.macromedia.timeentry.TimeEntryData;

class com.macromedia.timeentry.TimeEntry extends mx.screens.Form {
	
	var btnLoad:mx.controls.Button;
	var btnClear:mx.controls.Button;
	var btnFilter:mx.controls.Button;
	var btnAdd:mx.controls.Button;
	var btnRemove:mx.controls.Button;
	var btnSave:mx.controls.Button;
	var dmTimeEntry = null;
	var grdTimeEntry:mx.controls.DataGrid;
	var dtFldFrom:mx.controls.DateField;	
	var dtFldTo:mx.controls.DateField;	
	
	// PhilFlash
	var btnSaveWithError:mx.controls.Button;
	public var generateError:Boolean = false;
	
	/**
	  initialize class.
	*/
	function TimeEntry() {
		super();
		dmTimeEntry = _root.application.dmTimeEntry;
		addEventListener("load", onLoad);		
	}

	/**
	  initialize components that live within this form.  Setup listeners for events that I am interested in 
	  responding to within the context of the TimeEntry class.
	*/
	function onLoad(): Void {
		btnFilter.addEventListener("click", function(evt: Object) { evt.target._parent.btnFilterClickHandler(evt); } );
		btnLoad.addEventListener("click", function(evt: Object) { evt.target._parent.btnLoadClickHandler(evt); } );
		btnAdd.addEventListener("click", function(evt: Object) { evt.target._parent.btnAddClickHandler(); } );
		btnRemove.addEventListener("click", function(evt: Object) { evt.target._parent.btnRemoveClickHandler(); } );
		btnSave.addEventListener("click", function(evt: Object) { evt.target._parent.btnSaveClickHandler(); } );
		
		// PhilFlash
		btnSaveWithError.addEventListener("click", function(evt: Object) { evt.target._parent.btnSaveWithErrorClickHandler(); } );

		setupForm();
	}
	
	/**
	  append a new time entry.
	*/
	function btnAddClickHandler():Void {
		dmTimeEntry.addTimeEntry();
	}

	/**
	  append a new time entry.
	*/
	function btnFilterClickHandler():Void {
		dmTimeEntry.filterTimeEntriesByDate(dtFldFrom.selectedDate, dtFldTo.selectedDate);
	}

	/**
	  load data for this application.  The datamodule determines where to load the data from based on the users settings 
	  in the MenuBar.
	*/
	function btnLoadClickHandler(evt:Object):Void {
		dmTimeEntry.loadData();
	}

	/**
	  remove the selected time entry.
	*/
	function btnRemoveClickHandler():Void {
		dmTimeEntry.removeTimeEntry();
	}

	/**
	  Save any pending changes.  The datamodule determines where to save the data based on the users settings in the MenuBar.
	*/
	function btnSaveClickHandler():Void {
		// PhilFlash
		generateError = false;
		
		dmTimeEntry.saveTimeEntryData();
		dmTimeEntry.saveProjectData();
	}
	
	// PhilFlash
	function btnSaveWithErrorClickHandler():Void {
		// PhilFlash
		generateError = true;
		
		dmTimeEntry.saveTimeEntryData();
		dmTimeEntry.saveProjectData();
	}

	/**
	  helper function used to format dates that are displayed using the DateField component.
	*/
	function formatDate(d:Date) {
		return ( (d.getMonth()<9?"0"+(d.getMonth()+1):d.getMonth()+1 ) + "-" + ( d.getDate()<10?"0"+d.getDate():d.getDate() ) + "-" + d.getFullYear() );
	}

	/**
	  setup the visual aspects of the form including the DataGrid.
	*/
	function setupForm(): Void {
		setupGrid();
		dtFldFrom.dateFormatter = formatDate;
		dtFldTo.dateFormatter = formatDate;
	}
	
	/**
	  customize the DataGrid to display and format the columns that I am interested in displaying to the user.
	*/
	function setupGrid(): Void {
		//customize the DataGrid
		grdTimeEntry.columnNames = ["ID", "DATE", "BILLABLE", "DURATION", "RATE", "COST"];
		
		//mixin method so that DataSet can provide correct data types for cell renderers
		Object(grdTimeEntry).getBindingMetaData = function( info ) {
			if( info == "acceptedTypes" )
				return( {BILLABLE:"Boolean"} );
			else
				return( null );
			} 

		//customize columns
		var idCol:mx.controls.gridclasses.DataGridColumn = grdTimeEntry.getColumnAt(0);
		idCol.width = 30;
		idCol.headerText = "Id";

		var dateCol:mx.controls.gridclasses.DataGridColumn = grdTimeEntry.getColumnAt(1);
		dateCol.width = 80;
		dateCol.headerText = "Date";
		
		var billableCol:mx.controls.gridclasses.DataGridColumn = grdTimeEntry.getColumnAt(2);
		billableCol.width = 50;
		billableCol.cellRenderer = "CheckCellRenderer";
		billableCol.headerText = "Billable";
		billableCol.editable = false;
	
		var hoursCol:mx.controls.gridclasses.DataGridColumn = grdTimeEntry.getColumnAt(3);
		hoursCol.width = 60;
		hoursCol.headerText = "Hours";
		
		var rateCol:mx.controls.gridclasses.DataGridColumn = grdTimeEntry.getColumnAt(4);
		rateCol.width = 80;
		rateCol.headerText = "Rate";

		var costCol:mx.controls.gridclasses.DataGridColumn = grdTimeEntry.getColumnAt(5);
		costCol.width = 80;
		costCol.headerText = "Cost";

	}
}